=== cmake_targets/lte_noS1_build_oai/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8)
set(XFORMS 1 )
set(RRC_ASN1_VERSION "Rel10")
set(ENABLE_VCD_FIFO False )
set(RF_BOARD "EXMIMO")
set(NAS 1)
set(ENABLE_ITTI False)
set(ENABLE_USE_MME False)
set(LINK_ENB_PDCP_TO_GTPV1U False)
set(SECU False)
set(NAS_UE False)
set(PACKAGE_NAME "\"lte-softmodem\"")
include(${CMAKE_CURRENT_SOURCE_DIR}/../CMakeLists.txt)
