=== cmake_targets/autotests/test.0104/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8)
set(PACKAGE_NAME "unitary_tests_simulators")
set(PHYSIM True)
set(RF_BOARD None)
set(XFORMS False)

set(DEBUG_PHY False)
set(MU_RECIEVER Flase)
set(RANDOM_BF False)
set(PBS_SIM False)
set(PERFECT_CE True)

include(${CMAKE_CURRENT_SOURCE_DIR}/../../CMakeLists.txt)
