=== openair-cn/OPENAIRHSS/debian/changelog ===
openair-hss (1.0.0-1) UNRELEASED; urgency=low

  * Initial release. (Closes: #XXXXXX)

 -- Sebastien Roux <roux@nord>  Wed, 10 Apr 2013 09:54:55 +0200
