=== openair-cn/OPENAIRHSS/debian/control ===
Source: openair-hss
Maintainer: Sebastien ROUX <sebastien.roux@eurecom.fr>
Section: misc
Priority: optional
Standards-Version: 3.9.2
Build-Depends: debhelper (>= 8),
    make, gcc, bison, flex, autotools,
    libmysqlclient-dev, libsctp-dev,
    freediameter-dev, freediameter-dictionary-s6a, freediameter-dictionary-mip6,
    libgmp-dev, libnettle-dev

Package: openair-hss
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Implementation of R10 HSS for 3GPP LTE core network
